<?xml version="1.0" encoding="iso-8859-2"?>

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:output method="html"/>
<xsl:template match="test">
	<html>
		<title><xsl:value-of select="info/title"/></title>
		<style>
			.group {text-align:center;color:blue;font-size:16px;font-weight:bold;}
			.true {color:blue;}
		</style>
		<body>
			<xsl:apply-templates select="info"/>
			<xsl:apply-templates select="group"/>
		</body>
	</html>
</xsl:template>
<xsl:template match="info">
	<xsl:value-of select="subject"/><br/>
	<xsl:value-of select="title"/><br/>
	Autor: <xsl:value-of select="author"/><br/>
	Data: <xsl:value-of select="date"/><br/>
	<xsl:copy-of select="note"/>
</xsl:template>



<xsl:template match="group">
	<p class="group"><xsl:value-of select="@name"/></p>
	<ol>
		<xsl:apply-templates select="item"/>
	</ol>
</xsl:template>
<xsl:template match="item">
	<li>
		<xsl:value-of select="question"/>
		<ol type="a">
			<xsl:apply-templates select="answer"/>
		</ol>
	</li>
</xsl:template>
<xsl:template match="answer">
	<xsl:choose>
		<xsl:when test="@true='yes'">
			<li class="true"> <xsl:value-of select="."/></li>
		</xsl:when>
		<xsl:otherwise>
			 <li><xsl:value-of select="."/></li>
		</xsl:otherwise>
	</xsl:choose> 
</xsl:template>
</xsl:stylesheet>
