package pl.put.poznan.metrics.calculators.mood;

import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;

import org.eclipse.core.runtime.CoreException;
import org.eclipse.jdt.core.IJavaElement;
import org.eclipse.jdt.core.IJavaProject;
import org.eclipse.jdt.core.IMethod;
import org.eclipse.jdt.core.IType;
import org.eclipse.jdt.core.search.SearchMatch;
import org.eclipse.jdt.core.search.SearchRequestor;

import pl.put.poznan.metrics.util.Logger;
import pl.put.poznan.metrics.util.Util;
import poznan.students.utils.CalculatorCache;

public class CFSearchCallback extends SearchRequestor {

//	public static Map couplingMap = new HashMap();
	
	private IType searchType;
	private IJavaProject iProject;
	
	public CFSearchCallback(IType type, IJavaProject proj){
		searchType = type;
		iProject = proj;
	}
	
	public void acceptSearchMatch(SearchMatch match) throws CoreException {
		
		CalculatorCache calcCache = Util.getProjectCache(iProject.getElementName());
		
		IJavaElement enclosingElement = (IJavaElement) match.getElement();
		
		if (( enclosingElement.getElementType() != IJavaElement.FIELD) && 
			( enclosingElement.getElementType() != IJavaElement.LOCAL_VARIABLE)	&&
			( enclosingElement.getElementType() != IJavaElement.METHOD)&&
			//( enclosingElement.getElementType() != IJavaElement.TYPE) &&
			( enclosingElement.getElementType() != IJavaElement.TYPE_PARAMETER)	){
			Logger.logMessage("Znaleziony element jest typu = " + enclosingElement.getElementType());
			Logger.logMessage("Typ niewlasciwy. Wyjscie");
			return;
			
		}
		//wychodzimy jesli to jest inny projekt
		if ( !enclosingElement.getJavaProject().equals(iProject)){
			Logger.logMessage("Inny projekt niz aktualny. Wyjscie");
			return;
		}
		
		//pobieramy typ ( klasa, interfejs ) jakim zostaa znaleziona referencja
		IType foundType = getTypeFromElement(enclosingElement);
		
		if ( foundType.equals(searchType) ) return;
		
		String key = foundType.getFullyQualifiedName();
		Object ob = calcCache.getCouplingMap().get(key);
		
		if ( null == ob){
			ob = new HashSet();
		}
		
		//zapisujemy, ze znaleziony typo korzysta z poszukiwanej klasy
		Set couplingset = (Set) ob;
		couplingset.add(searchType);
		calcCache.getCouplingMap().put(key,couplingset);
		
		Util.getProjectCache().put(iProject.getElementName(),calcCache);
		
		Logger.logMessage("CF found in = " + foundType.getElementName());
		
	}
	
	public IType getTypeFromElement(IJavaElement elem){
		//System.out.println("ELEM TYPE = " + elem.getElementType());
		
		int elemType = elem.getElementType();
		while ( elemType != IJavaElement.TYPE){
			elem = elem.getParent();
			elemType = elem.getElementType();
		}
		
		return (IType) elem;
		
	}
	

}
