package pl.put.poznan.metrics.util;

import java.util.ResourceBundle;
import net.sourceforge.metrics.core.Log;

/**
 * Klasa rozszerzajca moliwoi loggera z projektu Metrics
 * @author Marek Bagiski
 */

public class Logger {
	/**
	 * Zawiera informacje czy aplikacja jest uywana w trybie <code>debug</code>
	 */
	private static Boolean DEBUG_MODE = null;

	/**
	 * Gdy aplikacja dziaa w trybie debug, wyswietla komunikat na konsoli oraz
	 * w logach Eclipse'a.
	 * 
	 * @param msg -
	 *            komunikat umieszczany w logu plikacji
	 */

	public static void logMessage(String msg) {
		if (null == DEBUG_MODE) {
			ResourceBundle bundle = ResourceBundle.getBundle("config/config");
			DEBUG_MODE = new Boolean((bundle.getString("debug")));
		}

		if (DEBUG_MODE.booleanValue()) {
			Log.logMessage(msg);
			System.out.println(msg);
		}
	}

	/**
	 * Loguje komunikat bdu
	 * 
	 * @param msg -
	 *            komunikat umieszczany w logu plikacji
	 * @param thr
	 */

	public static void logError(String msg, Throwable thr) {
		Log.logError(msg, thr);
	}

}
