package pl.put.poznan.metrics.test;

import junit.framework.TestCase;
import net.sourceforge.metrics.calculators.Calculator;
import net.sourceforge.metrics.calculators.InvalidSourceException;
import net.sourceforge.metrics.core.Metric;
import net.sourceforge.metrics.core.sources.AbstractMetricSource;
import net.sourceforge.metrics.core.sources.ProjectMetrics;

import org.eclipse.core.resources.IProject;
import org.eclipse.core.resources.ResourcesPlugin;
import org.eclipse.jdt.core.JavaCore;
import org.eclipse.jdt.core.JavaModelException;

import pl.put.poznan.metrics.calculators.mood.AttributeHidingFactor;
import pl.put.poznan.metrics.util.ExtensionsConstants;
import pl.put.poznan.metrics.util.Util;

public class AHFTest extends TestCase {
	AbstractMetricSource project100;
	AbstractMetricSource project50;
	AbstractMetricSource project0;
		
	protected void setUp() throws Exception {
		//projekt 100
		IProject project = ResourcesPlugin.getWorkspace().getRoot().getProject("MHFAHF100");
				
		project100 = new ProjectMetrics();
		project100.setJavaElement(JavaCore.create(project));
//		projekt 50
		IProject iProject50 = ResourcesPlugin.getWorkspace().getRoot().getProject("MHFAHF50");
						
		project50 = new ProjectMetrics();
		project50.setJavaElement(JavaCore.create(iProject50));
//		projekt 0
		IProject iProject0 = ResourcesPlugin.getWorkspace().getRoot().getProject("MHFAHF0");
				
		project0 = new ProjectMetrics();
		project0.setJavaElement(JavaCore.create(iProject0));
		
		Util.clearCacheData();
		
	}

	public void testAHF100() throws JavaModelException, InvalidSourceException{
		
		Calculator calc = new AttributeHidingFactor();
		calc.calculate(project100);
		Metric metric = project100.getValue(ExtensionsConstants.AHF);
		assertEquals(100,metric.getValue(),0.1);
		
	}
	
	public void testAHF50() throws JavaModelException, InvalidSourceException{
		
		Calculator calc = new AttributeHidingFactor();
		calc.calculate(project50);
		Metric metric = project50.getValue(ExtensionsConstants.AHF);
		assertEquals(50,metric.getValue(),0.1);
		
	}

	public void testAHF0() throws JavaModelException, InvalidSourceException{
	
		Calculator calc = new AttributeHidingFactor();
		calc.calculate(project0);
		Metric metric = project0.getValue(ExtensionsConstants.AHF);
		assertEquals(0,metric.getValue(),0.1);
	
	}
	
	protected void tearDown() throws Exception {
		
	}

}
