package pl.put.poznan.metrics.test;

import net.sourceforge.metrics.calculators.Calculator;
import net.sourceforge.metrics.calculators.InvalidSourceException;
import net.sourceforge.metrics.core.Metric;
import net.sourceforge.metrics.core.sources.AbstractMetricSource;
import net.sourceforge.metrics.core.sources.TypeMetrics;

import org.eclipse.core.resources.IProject;
import org.eclipse.core.resources.ResourcesPlugin;
import org.eclipse.jdt.core.ICompilationUnit;
import org.eclipse.jdt.core.IJavaProject;
import org.eclipse.jdt.core.IPackageFragment;
import org.eclipse.jdt.core.IType;
import org.eclipse.jdt.core.JavaCore;
import org.eclipse.jdt.core.JavaModelException;

import pl.put.poznan.metrics.calculators.ck.CouplingBetweenObject;
import pl.put.poznan.metrics.calculators.mood.AttributeInheritanceFactorPerClass;
import pl.put.poznan.metrics.util.ExtensionsConstants;
import junit.framework.TestCase;

public class CBOTest extends TestCase {
	AbstractMetricSource source3;
	AbstractMetricSource source2;
	AbstractMetricSource source0;
		
	protected void setUp() throws Exception {
		IProject project = ResourcesPlugin.getWorkspace().getRoot().getProject("CBOTest");
		project.open(null);
		IJavaProject iJavaProject = JavaCore.create(project);
		iJavaProject.open(null);
		IPackageFragment[] packageFrag = iJavaProject.getPackageFragments();
		for (int i = 0; i < packageFrag.length; i++) {
			//System.out.println("nazwa pakietu = " + packageFrag[i].getElementName());
			if ( TestConsts.PACKAGE_NAME.equalsIgnoreCase(packageFrag[i].getElementName())){
				ICompilationUnit compilationUnit = packageFrag[i].getCompilationUnit("CboTest0.java");
				IType type0 = compilationUnit.getType("CboTest0");
				source0 = new TypeMetrics();
				source0.setJavaElement(type0);
				
				ICompilationUnit compilationUnit50 = packageFrag[i].getCompilationUnit("CboTest2.java");
				IType type2 = compilationUnit50.getType("CboTest2");
				source2 = new TypeMetrics();
				source2.setJavaElement(type2);
				
				ICompilationUnit compilationUnit0 = packageFrag[i].getCompilationUnit("CboTest3.java");
				IType type3 = compilationUnit0.getType("CboTest3");
				source3 = new TypeMetrics();
				source3.setJavaElement(type3);
			}
		}
	}

	public void testCBOTest0() throws JavaModelException, InvalidSourceException{
		
		Calculator calc = new CouplingBetweenObject();
		calc.calculate(source0);
		Metric metric = source0.getValue(ExtensionsConstants.CBO);
		assertEquals(0,metric.getValue(),0.1);
		
	}
	
	public void testCBOTest2() throws JavaModelException, InvalidSourceException{
		
		Calculator calc = new CouplingBetweenObject();
		calc.calculate(source2);
		Metric metric = source2.getValue(ExtensionsConstants.CBO);
		assertEquals(2,metric.getValue(),0.1);
		
	}

	public void testCBOTest3() throws JavaModelException, InvalidSourceException{
	
		Calculator calc = new CouplingBetweenObject();
		calc.calculate(source3);
		Metric metric = source3.getValue(ExtensionsConstants.CBO);
		assertEquals(3,metric.getValue(),0.1);
	
	}
	
	protected void tearDown() throws Exception {
		
	}
}
