package pl.put.poznan.metrics.test;

import junit.framework.TestCase;
import net.sourceforge.metrics.calculators.Calculator;
import net.sourceforge.metrics.calculators.InvalidSourceException;
import net.sourceforge.metrics.core.Metric;
import net.sourceforge.metrics.core.sources.AbstractMetricSource;
import net.sourceforge.metrics.core.sources.ProjectMetrics;

import org.eclipse.core.resources.IProject;
import org.eclipse.core.resources.ResourcesPlugin;
import org.eclipse.jdt.core.JavaCore;
import org.eclipse.jdt.core.JavaModelException;

import pl.put.poznan.metrics.calculators.mood.CouplingFactor;
import pl.put.poznan.metrics.calculators.mood.MethodHidingFactor;
import pl.put.poznan.metrics.util.ExtensionsConstants;
import pl.put.poznan.metrics.util.Util;

public class CFTest extends TestCase {
	AbstractMetricSource project30;
	AbstractMetricSource project125;
	
		
	protected void setUp() throws Exception {
		//projekt o wybiku 30
		IProject project = ResourcesPlugin.getWorkspace().getRoot().getProject("CFTest30");
				
		project30 = new ProjectMetrics();
		project30.setJavaElement(JavaCore.create(project));
		
		//		projekt o wyniku 12.5
		IProject iProject125 = ResourcesPlugin.getWorkspace().getRoot().getProject("CFTest125");
						
		project125 = new ProjectMetrics();
		project125.setJavaElement(JavaCore.create(iProject125));
				
		Util.clearCacheData();
		
	}

	public void testCF30() throws JavaModelException, InvalidSourceException{
		
		Calculator calc = new CouplingFactor();
		calc.calculate(project30);
		Metric metric = project30.getValue(ExtensionsConstants.CF);
		assertEquals(30,metric.getValue(),0.1);
		
	}
	
	public void testMHF50() throws JavaModelException, InvalidSourceException{
		
		Calculator calc = new CouplingFactor();
		calc.calculate(project125);
		Metric metric = project125.getValue(ExtensionsConstants.CF);
		assertEquals(12.5,metric.getValue(),0.1);
		
	}

	protected void tearDown() throws Exception {
		
	}
}