package pl.put.poznan.metrics.test;

import junit.framework.TestCase;
import net.sourceforge.metrics.calculators.Calculator;
import net.sourceforge.metrics.calculators.InvalidSourceException;
import net.sourceforge.metrics.core.Metric;
import net.sourceforge.metrics.core.sources.AbstractMetricSource;
import net.sourceforge.metrics.core.sources.TypeMetrics;

import org.eclipse.core.resources.IProject;
import org.eclipse.core.resources.ResourcesPlugin;
import org.eclipse.jdt.core.ICompilationUnit;
import org.eclipse.jdt.core.IJavaProject;
import org.eclipse.jdt.core.IPackageFragment;
import org.eclipse.jdt.core.IType;
import org.eclipse.jdt.core.JavaCore;
import org.eclipse.jdt.core.JavaModelException;

import pl.put.poznan.metrics.calculators.mood.MethodHidingFactorPerClass;
import pl.put.poznan.metrics.util.ExtensionsConstants;

public class MHFPerClassTest extends TestCase {
	AbstractMetricSource source100;
	AbstractMetricSource source50;
	AbstractMetricSource source0;
		
	protected void setUp() throws Exception {
		IProject project = ResourcesPlugin.getWorkspace().getRoot().getProject("Testowy");
		project.open(null);
		IJavaProject iJavaProject = JavaCore.create(project);
		iJavaProject.open(null);
		IPackageFragment[] packageFrag = iJavaProject.getPackageFragments();
		for (int i = 0; i < packageFrag.length; i++) {
			if ( TestConsts.PACKAGE_NAME.equalsIgnoreCase(packageFrag[i].getElementName())){
				ICompilationUnit compilationUnit = packageFrag[i].getCompilationUnit("MHFTest100.java");
				IType type = compilationUnit.getType("MHFTest100");
				source100 = new TypeMetrics();
				source100.setJavaElement(type);
				
				ICompilationUnit compilationUnit50 = packageFrag[i].getCompilationUnit("MHFTest50.java");
				IType type50 = compilationUnit50.getType("MHFTest50");
				source50 = new TypeMetrics();
				source50.setJavaElement(type50);
				
				ICompilationUnit compilationUnit0 = packageFrag[i].getCompilationUnit("MHFTest0.java");
				IType type0 = compilationUnit0.getType("MHFTest0");
				source0 = new TypeMetrics();
				source0.setJavaElement(type0);
			}
		}
	}

	public void testMHFPerClass100() throws JavaModelException, InvalidSourceException{
		
		Calculator calc = new MethodHidingFactorPerClass();
		calc.calculate(source100);
		Metric metric = source100.getValue(ExtensionsConstants.MHF_PER_CLASS);
		assertEquals(100,metric.getValue(),0.1);
		
	}
	
	public void testMHFPerClass50() throws JavaModelException, InvalidSourceException{
		
		Calculator calc = new MethodHidingFactorPerClass();
		calc.calculate(source50);
		Metric metric = source50.getValue(ExtensionsConstants.MHF_PER_CLASS);
		assertEquals(50,metric.getValue(),0.1);
		
	}

	public void testMHFPerClass0() throws JavaModelException, InvalidSourceException{
	
		Calculator calc = new MethodHidingFactorPerClass();
		calc.calculate(source0);
		Metric metric = source0.getValue(ExtensionsConstants.MHF_PER_CLASS);
		assertEquals(0,metric.getValue(),0.1);
	
	}
	
	protected void tearDown() throws Exception {
		
	}
}
