package pl.put.poznan.metrics.test;

import junit.framework.TestCase;
import net.sourceforge.metrics.calculators.Calculator;
import net.sourceforge.metrics.calculators.InvalidSourceException;
import net.sourceforge.metrics.core.Metric;
import net.sourceforge.metrics.core.sources.AbstractMetricSource;
import net.sourceforge.metrics.core.sources.TypeMetrics;

import org.eclipse.core.resources.IProject;
import org.eclipse.core.resources.ResourcesPlugin;
import org.eclipse.jdt.core.ICompilationUnit;
import org.eclipse.jdt.core.IJavaProject;
import org.eclipse.jdt.core.IPackageFragment;
import org.eclipse.jdt.core.IType;
import org.eclipse.jdt.core.JavaCore;
import org.eclipse.jdt.core.JavaModelException;

import pl.put.poznan.metrics.calculators.mood.MethodInheritanceFactorPerClass;
import pl.put.poznan.metrics.util.ExtensionsConstants;

public class MIFPerClassTest extends TestCase {
	
	AbstractMetricSource source100;
	AbstractMetricSource source50;
			
	protected void setUp() throws Exception {
		IProject project = ResourcesPlugin.getWorkspace().getRoot().getProject("Testowy");
		IJavaProject iJavaProject = JavaCore.create(project);
		
		IPackageFragment[] packageFrag = iJavaProject.getPackageFragments();
		for (int i = 0; i < packageFrag.length; i++) {
			if ( TestConsts.PACKAGE_NAME.equalsIgnoreCase(packageFrag[i].getElementName())){
				ICompilationUnit compilationUnit = packageFrag[i].getCompilationUnit("MIFTest100.java");
				IType type = compilationUnit.getType("MIFTest100");
				source100 = new TypeMetrics();
				source100.setJavaElement(type);
				
				ICompilationUnit compilationUnit50 = packageFrag[i].getCompilationUnit("MIFTest50.java");
				IType type50 = compilationUnit50.getType("MIFTest50");
				source50 = new TypeMetrics();
				source50.setJavaElement(type50);
				
			}
		}
	}

	public void testMIFPerClas100() throws JavaModelException, InvalidSourceException{
		
		Calculator calc = new MethodInheritanceFactorPerClass();
		calc.calculate(source100);
		Metric metric = source100.getValue(ExtensionsConstants.MIF_PER_CLASS);
		assertEquals(100,metric.getValue(),0.1);
		
	}
	
	public void testMIFPerClass50() throws JavaModelException, InvalidSourceException{
		
		Calculator calc = new MethodInheritanceFactorPerClass();
		calc.calculate(source50);
		Metric metric = source50.getValue(ExtensionsConstants.MIF_PER_CLASS);
		assertEquals(50,metric.getValue(),0.1);
		
	}

	protected void tearDown() throws Exception {
		
	}
}
