package pl.put.poznan.metrics.test;

import junit.framework.TestCase;
import net.sourceforge.metrics.calculators.Calculator;
import net.sourceforge.metrics.calculators.InvalidSourceException;
import net.sourceforge.metrics.core.Metric;
import net.sourceforge.metrics.core.sources.AbstractMetricSource;
import net.sourceforge.metrics.core.sources.TypeMetrics;

import org.eclipse.core.resources.IProject;
import org.eclipse.core.resources.ResourcesPlugin;
import org.eclipse.jdt.core.ICompilationUnit;
import org.eclipse.jdt.core.IJavaProject;
import org.eclipse.jdt.core.IPackageFragment;
import org.eclipse.jdt.core.IType;
import org.eclipse.jdt.core.JavaCore;
import org.eclipse.jdt.core.JavaModelException;

import pl.put.poznan.metrics.calculators.ck.ResponseForAClass;
import pl.put.poznan.metrics.util.ExtensionsConstants;

public class RFCTest extends TestCase {
	AbstractMetricSource source10;
	AbstractMetricSource source5;
			
	protected void setUp() throws Exception {
		IProject project = ResourcesPlugin.getWorkspace().getRoot().getProject("Testowy");
		project.open(null);
		IJavaProject iJavaProject = JavaCore.create(project);
		iJavaProject.open(null);
		IPackageFragment[] packageFrag = iJavaProject.getPackageFragments();
		for (int i = 0; i < packageFrag.length; i++) {
			//System.out.println("nazwa pakietu = " + packageFrag[i].getElementName());
			if ( TestConsts.PACKAGE_NAME.equalsIgnoreCase(packageFrag[i].getElementName())){
				ICompilationUnit compilationUnit = packageFrag[i].getCompilationUnit("RFCTest10.java");
				IType type = compilationUnit.getType("RFCTest10");
				source10 = new TypeMetrics();
				source10.setJavaElement(type);
				
				ICompilationUnit compilationUnit50 = packageFrag[i].getCompilationUnit("RFCTest5.java");
				IType type50 = compilationUnit50.getType("RFCTest5");
				source5 = new TypeMetrics();
				source5.setJavaElement(type50);
				
			}
		}
	}

	public void testRFCPerClass10() throws JavaModelException, InvalidSourceException{
		
		Calculator calc = new ResponseForAClass();
		calc.calculate(source10);
		Metric metric = source10.getValue(ExtensionsConstants.RFC);
		assertEquals(10,metric.getValue(),0.1);
		
	}
	
	public void testRFCPerClass5() throws JavaModelException, InvalidSourceException{
		
		Calculator calc = new ResponseForAClass();
		calc.calculate(source5);
		Metric metric = source5.getValue(ExtensionsConstants.RFC);
		assertEquals(5,metric.getValue(),0.1);
		
	}

		
	protected void tearDown() throws Exception {
		
	}

}
